/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


Controller.TitleScreenController = function () {
    that = this;
    if (Controller.clientType === "phonegap")
        this.clientType = true;
    this.fileSystem = null;
    this.onlineReflectories = [];
    this.handlerOffline = null;
    this.handlerOnline = null;

    this.view = new TitleScreenView(this);
    this.loadReflectories();

};

/**
 * Loads online reflectories and fires OnlineLoaded event on success
 */
Controller.TitleScreenController.prototype.loadOnlineReflectories = function () {
    var that = this;
    // Do not try, if there is no connection
    if (Controller.clientType === "phonegap")
    {
        var networkState = navigator.connection.type;
        if (networkState === Connection.NONE) {
            return;
        }
    }
    $.ajax({
        type: "GET",
        url: app.ServerAddress + "api/",
        timeout: 3000,
        crossDomain: true,
        dataType: "json",
        async: true,
        success: function (data) {
            for (i = 0; i < data.length; i++)
            {
                data[i].id = i;
            }
            that.onlineReflectories = data;
            $(document).trigger("OnlineLoaded");
        },
        error: function () {
            alert('Failed to connect, please refresh');
        }
    });
};


/*
 * Initiates fileSystem Model and waits for file structure
 */
Controller.TitleScreenController.prototype.loadReflectories = function ()
{
    var that = this;

    if (Controller.clientType === "phonegap") {
        this.fileSystem = new Model.FileSystem();
        this.fileSystem.readDirectories();
        $(document).on("filesReady", that.handlerOffline = function () {
            that.update();
            that.loadOnlineReflectories();
            $(document).on("OnlineLoaded", that.handlerOnline = function () {
                that.update();
            });
        });

    }
    else {
        this.loadOnlineReflectories();
        $(document).on("OnlineLoaded", that.handlerOnline = function () {
            that.update();
        });
    }
};

/*
 * Updates the current titlescreen
 */
Controller.TitleScreenController.prototype.update = function ()
{


    this.view.refresh();
    this.view.render();
    this.addListener();
    $.mobile.changePage("#", {allowSamePageTransition: true, transition: "none"});

};

/*
 * Creating new NodeController for choosen Reflectory
 */

Controller.TitleScreenController.LoadPopupView = function (event)
{
    this.view = new PopupView(this.onlineReflectories[$(event.currentTarget).data("name")]);
};


Controller.TitleScreenController.prototype.eventHandler = function (event)
{
    $(document).unbind("filesReady", this.handlerOffline);
    $(document).unbind("OnlineLoaded", this.handlerOnline);
    //if offline App
    if ($(event.currentTarget).data("type") === 0) {
        Controller.baseURL = Controller.fileSystemRoot + "Reflectories/" + $(event.currentTarget).data("name");
    }
    //if online App
    else {
        Controller.baseURL = app.ServerAddress + "api/Modules/" + $(event.currentTarget).data("path");
    }

    var reflectoryContainer = new Model.ReflectoryContainer($(event.currentTarget).data("name"));

    reflectoryContainer.loadReflectories();

    Controller.reflectoryContainer = null;
    Controller.reflectoryContainer = reflectoryContainer;
    Controller.currentController = new Controller.NodeController();
};

/**
 * Listener for refresh button
 */
Controller.TitleScreenController.prototype.addListener = function ()
{
    that = this;

    //  Listener for refresh button click. Tries to load all reflectories from server
    $('#refresh').click(function () {

        $(document).unbind("filesReady", this.handlerOffline);
        $(document).unbind("OnlineLoaded", this.handlerOnline);
        that.loadReflectories();
        // $.mobile.changePage("#", {allowSamePageTransition: true});
        $(":mobile-pagecontainer").pagecontainer("change", "#", {allowSamePageTransition: true});


    });
};