/* 
 *Model for local File System
 */

Model.FileSystem = function ()
{
    this.reflectoryName;
    this.progressBar;
    this.fileSystem;
    this.targetFiles;
    this.ReflectoryRoot;
    this.ReflectoryEntries = [];
    this.filesCount;
    this.filesLoaded = 0;
};

//Entry point for Reflectory download. Which domObject should be the progresBar?
Model.FileSystem.prototype.downloadReflectory = function (reflectoryName, domObject)
{
    this.progressBar = domObject;
    this.reflectoryName = reflectoryName;
    this.getFiles(reflectoryName);
    $(this.progressBar).attr("max", this.targetFiles.length);
    this.ddl();
};

//Grabs next element to download
Model.FileSystem.prototype.ddl = function ()
{
    if (this.targetFiles.length > 0)
    {
        var file = this.targetFiles.pop();
        this.downloadFile(app.ServerAddress + "api/Modules/" + this.reflectoryName + file, "Reflectories/" + this.reflectoryName, file);
    }
};

Model.FileSystem.prototype.getFiles = function (reflectoryName)
{
    var that = this;
    $.ajax({
        type: "GET",
        url: app.ServerAddress + "/api/download.php?name=" + reflectoryName,
        async: false,
        timeout: 2000,
        dataType: "json",
        success: function (data) {
            that.targetFiles = data;
            that.filesCount = data.length;
        },
        error: function () {
            alert('error!');
        }
    });
};

Model.FileSystem.prototype.readConfig = function (path)
{
    var description;
    $.ajax({
        type: "GET",
        url: Controller.fileSystemRoot + path + "/config.json",
        async: false,
        timeout: 2000,
        dataType: "json",
        success: function (data) {
            description = data;
        },
        error: function () {
            alert('error!');
        }
    });
    return description;
};

//Reads all files from directory Reflectories and stores names and path in ReflectoriyEntries
Model.FileSystem.prototype.readDirectories = function ()
{
    var that = this;
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, requestFileSystemSuccess, null);

    function requestFileSystemSuccess(fileSystem) {
        Controller.fileSystemRoot = fileSystem.root.toURL();
        that.fileSystem = fileSystem;

        fileSystem.root.getDirectory("Reflectories", {create: true, exclusive: false}, success, fail);

        function success(parent) {
            var directoryReader = parent.createReader();
            directoryReader.readEntries(successEntry, null);
            function successEntry(entries) {
                var i;
                for (i = 0; i < entries.length; i++) {
                    var help = that.readConfig(entries[i].fullPath);
                    that.ReflectoryEntries.push({name: entries[i].name, path: entries[i].fullPath, id: i, description: help.description, dirname:help.name});
                }
                $(document).trigger("filesReady");
            }
        }

        function fail(error) {
            alert("Failed to list directory contents: " + error.code);
        }
    }
};

//Initializes filedownload and checks whether internet connection is available
Model.FileSystem.prototype.downloadFile = function (URL, Folder_Name, File_Name)
{
    //Parameters mismatch check
    if (URL === null && Folder_Name === null && File_Name === null) {
        return;
    }
    else {
        //checking Internet connection availablity
        var networkState = navigator.connection.type;
        if (networkState === Connection.NONE) {
            return;
        } else {
            this.download(URL, Folder_Name, File_Name); //If available download function call
        }
    }
};

//Downloads the file with given URL and saces it under File_Name into Folder_Name
Model.FileSystem.prototype.download = function (URL, Folder_Name, File_Name)
{
    var that = this;
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, fileSystemSuccess, fileSystemFail);

    function fileSystemSuccess(fileSystem) {
        var download_link = encodeURI(URL);
        ext = download_link.substr(download_link.lastIndexOf('.') + 1); //Get extension of URL

        var directoryEntry = fileSystem.root; // to get root path of directory
        directoryEntry.getDirectory(Folder_Name, {create: true, exclusive: false}, onDirectorySuccess, onDirectoryFail); // creating folder in sdcard
        var rootdir = fileSystem.root;

        var fp = rootdir.toURL(); // Returns Fulpath of local directory

        fp = fp + "/" + Folder_Name + "/" + File_Name;//+ "." + ext; // fullpath and name of the file which we want to give
        // download function call
        that.filetransfer(download_link, fp);
    }

    function onDirectorySuccess(parent) {
        // Directory created successfuly
    }

    function onDirectoryFail(error) {
        //Error while creating directory

        alert("Unable to create new directory: " + error.code);
    }

    function fileSystemFail(evt) {
        //Unable to access file system
        alert(evt.target.error.code);
        that.ddl();
    }
};

//Actual FileTransfer
Model.FileSystem.prototype.filetransfer = function (download_link, fp) {
    var that = this;
    var fileTransfer = new FileTransfer();
// File download function with URL and local path
    fileTransfer.download(download_link, fp,
            function (entry) {
                that.filesLoaded += 1;
                //alert("download complete: " + entry.fullPath);
                $(that.progressBar).val(that.filesLoaded);
                if (that.targetFiles.length === 0)
                    $("#popupback").show();
                else
                    that.ddl();
            },
            function (error) {

                that.filesLoaded += 1;
                $(that.progressBar).val(that.filesLoaded);
                if (that.targetFiles.length === 0)
                    $("#popupback").show();
                else
                    that.ddl();
                //Download abort errors or download failed errors
                //alert("download error source " + error.source);
                //alert("download error target " + error.target);
                //alert("upload error code" + error.code);
            }
    );

};