/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


var Model = Model || {};

//<----- REFLECTORYCONTAINER CLASS BEGIN ----->
Model.ReflectoryContainer = function (name) {
    this.reflectories = [];
    this.nodeHistory = [];
    this.reflectoryName = name;
};



Model.ReflectoryContainer.prototype.addToNodeHistory = function (node) {
    this.nodeHistory.push(node);
};

Model.ReflectoryContainer.prototype.getLastFromNodeHistory = function (controller) {
    if (this.nodeHistory.length !== 0)
        return this.nodeHistory.pop();
    else
        return  controller.reflectoryContainer.reflectories[0].findNodebyId("n_0");
};

Model.ReflectoryContainer.prototype.findReflectoryByLanguage=function (language)
{
    
    var len = this.reflectories.length;
    //alert(len);
    for (i = 0; i < len; i++) {
        if (this.reflectories[i].language === language)
        {
            return this.reflectories[i];
        }
    }
   // return this.findReflectoryByLanguage("EN");
};

Model.ReflectoryContainer.prototype.loadReflectories = function ()
{
    var xml;
    var that = this;
    //alert(Controller.baseURL + "/" + that.reflectoryName + ".xml");
//alert(app.ServerAddress + "/" + that.reflectoryName + ".xml");
//alert(Controller.baseURL);
    //First we have to load data synchronious, If we have all data, we can store it in our variable;
    $.ajax({
        type: "GET",
        url: Controller.baseURL + "/" + that.reflectoryName + ".xml",
        async: false,
        timeout: 2000,
        dataType: "xml",
        success: function (data) {
            xml = data;
        },
        error: function () {
            alert('error!');
        }
    });


    var that = this;
    var ref = $(xml).find("language");

    //alert(xml.querySelector("textfield").innerHTML);
    // For each language add new Reflectory into ReflectoryContainer   
    ref.each(function (index, value) {
        var reflectory = new Model.Reflectory(value);
        reflectory.language=$(value).attr("languageType");
        that.reflectories.push(reflectory);
    });

    // alert(this.reflectories.toString());
    //alert (this.a);

};

Model.ReflectoryContainer.prototype.loadAudio = function (link)
{
    var audioElement = document.createElement('audio');
    audioElement.setAttribute('src', link);
    return audioElement;
};

//<----- REFLECTORYCONTAINER CLASS END ----->


//<----- REFLECTORY CLASS BEGIN ----->

Model.Reflectory = function (domObj) {
    this.title;
    this.description;
    this.nodes = [];
    this.logo;
    this.loadReflectory(domObj);



};

//Loads Reflectory according to the DOM object
Model.Reflectory.prototype.loadReflectory = function (domObj)
{
    this.title = ($(domObj).find("title").text());
    this.logo = ($(domObj).find("logo").text());
    this.description = ($(domObj).find("description").text());
    var that = this;
    var ref = $(domObj).find("node");
    //For each node add it to node array
    ref.each(function (index, value) {
        var node = new Model.Node(value);
        that.nodes.push(node);
    });
};

Model.Reflectory.prototype.findNodebyId = function (Id)
{
    var len = this.nodes.length;
    for (i = 0; i < len; i++) {
        if (this.nodes[i].nodeId == Id)
        {
            return this.nodes[i];
        }
    }
};

//<----- REFLECTORY CLASS END ----->


//<----- NODE CLASS BEGIN ----->

Model.Node = function (domObj) {
    this.nodeId;
    this.nodeTitle;
    this.description;
    this.audio;
    this.decisionContainerDescription;
    this.descicions = [];
    this.decisionContainers = [];
    this.images = [];
    this.pdf = [];
    this.video = [];
    this.text = [];
    this.isAudioFinished =false;
    this.loadNode(domObj);

};


Model.Node.prototype.loadNode = function (domObj)
{
    this.nodeId = (($(domObj).attr("nodeId")));
    this.nodeTitle = $(domObj).find("nodetitle").text();
    //alert($(domObj).find("textfield").html());
    var s = new XMLSerializer();
    var help = (s.serializeToString(domObj.querySelector('textfield')));
    //var help =$(domObj).find("textfield");
    this.description = help;
    //this.description = $(domObj).find("textfield").html();
    this.audio = $(domObj).find("audio").text();
    var that = this;
    var image = $(domObj).find("image");
    image.each(function (index, value) {
        var img = new Model.Image($(value).attr("name"), $(value).text());
        that.images.push(img);
    });
    
    var decisionContainer = $(domObj).find("decisionContainer");
    decisionContainer.each(function (index, value) {
        that.decisionContainers.push(new Model.DecisionContainer(value));
    });
    this.decisionContainerDescription= $(decisionContainer).find("description").text();
    
    var descicion = $(domObj).find("decision");
    descicion.each(function (index, value) {
        var descicion = new Model.Descicion($(value).attr("nodeId"), $(value).text());
        that.descicions.push(descicion);
    });
    
    var s = new XMLSerializer();
    var pdf = $(domObj).find("pdf");
    pdf.each(function (index, value) {
       //that.pdf.push();
       var pdf= new Model.PDF($(value).attr("name"),s.serializeToString(value));
       that.pdf.push(pdf);
    });

    var video = $(domObj).find("video");
    video.each(function (index, value) {
        that.video.push($(value).text());
    });

    var text = $(domObj).find("text");
    text.each(function (index, value) {
        that.text.push($(value).text());
    });
};
//<----- NODE CLASS END ----->


//<----- DESCICION CLASS BEGIN ----->

Model.Descicion = function (nodeId, descicion)
{
    this.descicionText = descicion;
    this.targetNode = nodeId;

};

//<----- DESCICION CLASS END ----->

//<----- IMAGE CLASS BEGIN ----->
Model.Image =function(name,link)
{
    this.description=name;
    this.link = link;
};
//<----- IMAGE CLASS END ----->

//<----- IMAGE CLASS BEGIN ----->
Model.PDF =function(name,link)
{
    this.description=name;
    this.link = link;
};
//<----- IMAGE CLASS END ----->

Model.DecisionContainer = function(container)
{
    var that =this;
    this.description=$(container).find("description").text();
    this.decisions=[];
    var decisions=$(container).find("decision");
    decisions.each(function (index, value) {
        var descicion = new Model.Descicion($(value).attr("nodeId"), $(value).text());
        that.decisions.push(descicion);
    });
};